<script lang="ts">
  import Button from '$lib/components/Button.svelte';
  import TextField from '$lib/components/fields/TextField.svelte';
  import SelectField from '$lib/components/fields/SelectField.svelte';
  import EmailField from '$lib/components/fields/EmailField.svelte';
  import { axiosInstance } from '$lib/config/index.js';
  import FileField from '$lib/components/fields/FileField.svelte';
  import { PUBLIC_API_URL } from '$env/static/public';

  export let ssa: any = null;

  let id: number,
    name: string,
    description: string,
    attachment: any;

  if (ssa) {
    id = ssa.id;
    name = ssa.name;
    description = ssa.description;
  }

  async function handleSubmit() {
    if (name && description && attachment) {
      let attachmentId = null;

      try {
        const resAttachment = await axiosInstance[attachment.id ? 'patch' : 'post'](`/attachment${attachment.id ? `/${attachment.id}` : ''}`, {
          file: attachment[0]
        }, {
          headers: {
            'Content-Type': 'multipart/form-data'
          }
        });

        attachmentId = resAttachment.data.data.id;

        if (resAttachment.status === 201 || resAttachment.status === 200) {
          const res = await axiosInstance[id ? 'patch' : 'post'](`/sno${id ? `/${id}` : ''}`, {
            name,
            description,
            attachment: attachmentId
          });

          if (res.status === 201) {
            window.location.href = '/admin/ssa';
          }

          if (res.status === 200) {
            alert('Успешно сохранено.');
          }
        }
      } catch (err: any) {
        console.error(err);

        await axiosInstance.delete(`/attachment/${attachmentId}`);

        switch (err.response.status) {
          case 400:
            alert('Неверные данные');
            break;
          default:
            alert('Возникла ошибка. Попробуйте повторить действие.');
        }
      }
    }
  }
</script>

<form
    method="post"
    on:submit|preventDefault={handleSubmit}
    class="{$$props.class} space-y-6 mx-auto max-w-screen-xl"
>
    <h1 class="text-6xl text-center mb-2 font-serif">
        {#if ssa}
            Изменение записи
            <p class="text-lg text-neutral-600"><span class="select-none">ID:</span>{id}</p>
        {:else}
            Создание записи
        {/if}
    </h1>

    {#if ssa}
        <img src="{PUBLIC_API_URL}/attachment/{ssa.attachment.id}" alt="" class="h-40 rounded">
    {/if}

    <FileField label="Файл" name="attachment" bind:files={attachment}/>
    <TextField label="Наименование" name="name" bind:value={name}/>
    <TextField label="Описание" name="description" bind:value={description}/>

    <section class="flex justify-center gap-6">
        <a href="/admin/ssa">
            <Button transparent>Отменить</Button>
        </a>
        <Button>
            {#if ssa}
                Изменить
            {:else}
                Создать
            {/if}
        </Button>
    </section>
</form>